unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, clipbrd, ComCtrls, shellapi, ExtCtrls, ScktComp;

type
  TformMenuPrincipal = class(TForm)
    LWEB: TLabel;
    z: TPageControl;
    tabPortapapeles: TTabSheet;
    tabConfiguracion: TTabSheet;
    btObtener: TButton;
    txtNumFormato: TMemo;
    Label1: TLabel;
    txtFormato: TEdit;
    Label2: TLabel;
    imScroll: TScrollBox;
    imagen: TImage;
    opAjustar: TCheckBox;
    temporizador: TTimer;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    txtMilisegundos: TEdit;
    Label4: TLabel;
    bGuardarConfiguracion: TButton;
    opLeerPortapapelesLocalAutomaticamente: TCheckBox;
    GroupBox2: TGroupBox;
    opPermitirCompartir: TCheckBox;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    txtIP: TEdit;
    txtPuerto: TEdit;
    Label6: TLabel;
    tabPortapapelesRemoto: TTabSheet;
    Edit1: TEdit;
    Label8: TLabel;
    txtTexto: TMemo;
    btGuardarPortapapeles: TButton;
    dlGuardar: TSaveDialog;
    btObtenerRemoto: TButton;
    btGuardarPortapapelesRemoto: TButton;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    lInfoPCRemoto: TStaticText;
    btAplicarCambios: TButton;
    Label7: TLabel;
    txtUbicacionTemporales: TEdit;
    socServidor: TServerSocket;
    servidor: TServerSocket;
    cliente: TClientSocket;
    socFichero: TClientSocket;
    tabLog: TTabSheet;
    txtLog: TMemo;
    btProbarConexion: TButton;
    btModoEscucha: TButton;
    procedure btObtenerClick(Sender: TObject);
    procedure opAjustarClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure temporizadorTimer(Sender: TObject);
    procedure bGuardarConfiguracionClick(Sender: TObject);
    procedure btGuardarPortapapelesClick(Sender: TObject);
    procedure tabPortapapelesRemotoShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure guardarConfiguracion ();
    procedure aplicarCambios;
    procedure cargarConfiguracion;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btAplicarCambiosClick(Sender: TObject);
    procedure clienteConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure clienteConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure clienteDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure clienteError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure clienteRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure socFicheroConnect(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure socFicheroDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure socServidorAccept(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure socServidorClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure socServidorClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure socServidorClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
    procedure socServidorClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure socServidorListen(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure servidorAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure servidorClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure servidorClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
    procedure servidorClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
    procedure servidorListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure btObtenerRemotoClick(Sender: TObject);
    procedure btProbarConexionClick(Sender: TObject);
    procedure btModoEscuchaClick(Sender: TObject);
  private
    { Private declarations }
    nombreFicheroEnvio : string;
    tamanoFichero : integer;
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  Stream : TFileStream;  

implementation

uses UnidadProcedimientos;

{$R *.dfm}

procedure TformMenuPrincipal.cargarConfiguracion ();
begin
  opLeerPortapapelesLocalAutomaticamente.Checked := leBoolINI('Lectura del portapapeles',
      'Activar comprobacin del portapapeles local automtica', false);
  txtMilisegundos.Text := inttostr(leNumINI('Lectura del portapapeles',
      'Comprobar portapapeles cada', 1000));
  txtUbicacionTemporales.Text := leCadINI('Obtener portapapeles remoto','Lectura del portapapeles', ExtractFilePath (Application.ExeName));      
  opPermitirCompartir.Checked := leBoolINI('Lectura del portapapeles',
      'Permitir compartir el portapapeles', false);
  txtIP.Text := leCadINI('Obtener portapapeles remoto','IP', '');
  txtPuerto.Text := inttostr(leNumINI('Obtener portapapeles remoto','Puerto', 9990));
end;

procedure TformMenuPrincipal.guardarConfiguracion ();
begin
  esBoolINI('Lectura del portapapeles',
      'Activar comprobacin del portapapeles local automtica',
      opLeerPortapapelesLocalAutomaticamente.Checked);
  esNumINI('Lectura del portapapeles', 'Comprobar portapapeles cada',
      strtoint(txtMilisegundos.Text));
  esBoolINI('Lectura del portapapeles', 'Permitir compartir el portapapeles',
      opPermitirCompartir.Checked);
  esCadINI('Obtener portapapeles remoto','Lectura del portapapeles', txtUbicacionTemporales.Text);
  esCadINI('Obtener portapapeles remoto','IP', txtIP.Text);
  esNumINI('Obtener portapapeles remoto','Puerto', strtoint(txtPuerto.Text));
end;

procedure TformMenuPrincipal.aplicarCambios;
begin
  temporizador.Interval := StrToInt(txtMilisegundos.Text);
  temporizador.Enabled := opLeerPortapapelesLocalAutomaticamente.Checked;
end;

procedure TformMenuPrincipal.btObtenerClick(Sender: TObject);
var
  i : integer;
  f: THandle;
  buffer: array [0..MAX_PATH] of Char;
  numFiles: Integer;
begin
  txtTexto.Clear;
  txtNumFormato.Clear;
  //para obtener los formatos actuales del portapapeles
  for i := 0 to 127 do
  begin
    if Clipboard.HasFormat(i) then
    begin
      case i of
        1 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_TEXT');
        2 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_BITMAP');
        3 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_METAFILEPICT');
        4 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_SYLK');
        5 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_DIF');
        6 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_TIFF');
        7 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_OEMTEXT');
        8 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_DIB');
        9 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_PALETTE');
        10 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_PENDATA');
        11 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_RIFF');
        12 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_WAVE');
        13 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_UNICODETEXT');
        14 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_ENHMETAFILE');
        15 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_HDROP');
        16 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_LOCALE');
        17 : txtNumFormato.Lines.Add (inttostr(i) + ' -> ' + 'CF_MAX');
      else
        txtNumFormato.Lines.Add(inttostr(i) + ' -> ' + 'Desconocido');
      end;
    end;
  end;

  //para texto
  if Clipboard.HasFormat(CF_TEXT) then
  begin
    txtTexto.Visible := true;
    imScroll.visible := false;
    opAjustar.Visible := false;
    txtTexto.Lines.Add (Clipboard.AsText);
    txtFormato.Text := 'Texto';
  end;

  //para enlace a fichero (o ficheros)
  if Clipboard.HasFormat(CF_HDROP) then
  begin
    txtTexto.Visible := true;
    imScroll.visible := false;
    opAjustar.Visible := false;
    txtFormato.Text := 'Enlace a fichero';
    Clipboard.Open;
    try
      f := Clipboard.GetAsHandle(CF_HDROP);
      if f <> 0 then
      begin
        numFiles := DragQueryFile(f, $FFFFFFFF, nil, 0);
        txtTexto.Clear;
        for i := 0 to numfiles - 1 do
        begin
          buffer[0] := #0;
          DragQueryFile(f, i, buffer, SizeOf(buffer));
          txtTexto.Lines.Add(buffer);
        end;
      end;
    finally
      Clipboard.Close;
    end;
  end;

  //para imagen
  if Clipboard.HasFormat(CF_BITMAP) then
  begin
    txtFormato.Text := 'Imagen';  
    txtTexto.Visible := false;
    imScroll.visible := true;
    opAjustar.Visible := true;
    imagen.Picture.Assign(Clipboard);
  end;
end;

procedure TformMenuPrincipal.opAjustarClick(Sender: TObject);
begin
  if opAjustar.Checked then
  begin
    imagen.Align := alClient;
    imagen.Stretch := true;
  end
  else
  begin
    imagen.Align := alNone;
    imagen.Stretch := false;
  end;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.temporizadorTimer(Sender: TObject);
begin
  btObtenerClick(Self);
end;

procedure TformMenuPrincipal.bGuardarConfiguracionClick(Sender: TObject);
begin
  guardarConfiguracion;
  aplicarCambios;
end;

procedure TformMenuPrincipal.btGuardarPortapapelesClick(Sender: TObject);
begin
  if imScroll.Visible then
  begin
    dlGuardar.Filter := 'Bitmap (*.bmp)|*.bmp';
    dlGuardar.Title := 'Guardar imagen del portapapeles';
    dlGuardar.FileName := 'imgportapapeles';
    dlGuardar.DefaultExt := 'bmp';
    if dlGuardar.Execute then
      imagen.Picture.SaveToFile (dlGuardar.FileName); 
  end;
  if txtTexto.Visible then
  begin
    dlGuardar.Filter := 'Texto (*.txt)|*.txt';
    dlGuardar.Title := 'Guardar texto del portapapeles';
    dlGuardar.FileName := 'textoportapapeles';
    dlGuardar.DefaultExt := 'txt';
    if dlGuardar.Execute then
      txtTexto.Lines.SaveToFile (dlGuardar.FileName);
  end;
end;

procedure TformMenuPrincipal.tabPortapapelesRemotoShow(Sender: TObject);
begin
  lInfoPCRemoto.Caption := 'Se obtendr el portapapeles del PC [' +
      txtIP.Text + '] utilizando el puerto [' + txtPuerto.Text + ']';
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  cargarConfiguracion;
  aplicarCambios;
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  guardarConfiguracion;
end;

procedure TformMenuPrincipal.btAplicarCambiosClick(Sender: TObject);
begin
  aplicarCambios;
end;

procedure TformMenuPrincipal.clienteConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Conectado a PC remoto ' + socket.RemoteAddress);
end;

procedure TformMenuPrincipal.clienteConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Conectado al PC remoto');
end;

procedure TformMenuPrincipal.clienteDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('PC remoto desconectado');
end;

procedure TformMenuPrincipal.clienteError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  txtLog.Lines.Add ('Problema con la conexin, cdigo de error: ' + IntToStr(ErrorCode));
  ErrorCode := 0;
end;

procedure TformMenuPrincipal.clienteRead(Sender: TObject; Socket: TCustomWinSocket);
var
  Data : String;
begin
  Data := Socket.ReceiveText;
  If Data = '!DONE' then
  begin
    memo1.lines.add('La transferencia del fichero ha finalizado.');
    socFichero.Close;
  end;
end;

procedure TformMenuPrincipal.socFicheroConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  FName : String;
begin
  txtLog.Lines.Add ('Transferencia del portapapeles iniciada');
  FName := nombreFicheroEnvio;
  socFichero.Socket.SendStream(TFileStream.Create(Fname, fmopenread));
  txtLog.Lines.Add ('Enviando portapapeles');
end;

procedure TformMenuPrincipal.socFicheroDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  memo1.lines.add('Transferencia de fichero finalizada.');
end;

procedure TformMenuPrincipal.socServidorAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Transfiriendo portapapeles');
end;

procedure TformMenuPrincipal.socServidorClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Se ha conectado correctamente al PC ' +  txtIP.Text);
end;

procedure TformMenuPrincipal.socServidorClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('PC remoto desconectado.');
end;

procedure TformMenuPrincipal.socServidorClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  txtLog.Lines.Add ('Error en la conexin con el PC remoto. Nmero de error ' +
      inttostr(ErrorCode) + '.');
  ErrorCode := 0;
end;

procedure TformMenuPrincipal.socServidorClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  buffer : array[0..999999] of char; //unsigned char
  FilePath : string;
  IncommingLen, RecievedLen : integer;
begin
  FilePath := ExtractFilePath(Application.ExeName);
  IncommingLen := socket.ReceiveLength;
  //recibe el tamao en bytes
  while IncommingLen > 0 do
  begin
    RecievedLen := socket.ReceiveBuf(Buffer, Sizeof(Buffer));
    //obtiene el buffer a partir de los bytes del fichero
    if RecievedLen <= 0 then
    begin
      Break
      //no hay ms datos que recibir
    end
    else
      Stream.Write(Buffer,RecievedLen);
    //ProgressBar1.StepBy(RecievedLen);
    //si el buffer tiene datos, los escribimos en el fichero
    if Stream.Size >= tamanoFichero then
      //si el fichero recibido (nuevo) tiene el mismo tamao que
      //el fichero enviado enviamos el comando DONE al cliente
      //para indicarle que la transferencia ha finalizado
    begin
      servidor.Socket.Connections[0].SendText('!DONE');
      txtLog.Lines.Add ('Portapapeles recibido correctamente');
      Stream.Free;
      socServidor.Close;
      //progressbar1.Position := 0;
      break;
    end;
  end;
end;

procedure TformMenuPrincipal.socServidorListen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Abriendo puerto del PC remoto');
end;

procedure TformMenuPrincipal.servidorAccept(Sender: TObject; Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Se ha conectado un PC remoto');
end;

procedure TformMenuPrincipal.servidorClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Recibiendo conexin de ' + socket.RemoteAddress);
end;

procedure TformMenuPrincipal.servidorClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  txtLog.Lines.Add ('Error en la conexin. Nmero de error ' + inttostr(ErrorCode));
  ErrorCode := 0;
end;

procedure TformMenuPrincipal.servidorClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  IncommingData, StrippedData, CommandName : String;
begin
  //progressbar1.position := 0;
  IncommingData := Socket.ReceiveText;
  StrippedData := copy(IncommingData,6,length(IncommingData));
  CommandName := copy(IncommingData,0,5);
  if CommandName = '!FILE' then
  begin
    txtLog.Lines.Add ('Recibiendo nombre de ...');
    Stream := TFileStream.Create(StrippedData, fmCREATE or fmopenwrite
        and fmsharedenywrite);
    nombreFicheroEnvio := StrippedData;
    socServidor.Port := 236;
    socServidor.Open;
  end;
  if CommandName = '!SIZE' then
  begin
    txtLog.Lines.Add ('Recibiendo tamao del portapapeles');
    nombreFicheroEnvio := StrippedData;
    //ProgressBar1.Max := strtoint(StrippedData);
    //progressbar1.min := 0;
  end;
end;

procedure TformMenuPrincipal.servidorListen(Sender: TObject; Socket: TCustomWinSocket);
begin
  txtLog.Lines.Add ('Escuchando PC remoto para recepcin de portapapeles');
end;

procedure TformMenuPrincipal.btObtenerRemotoClick(Sender: TObject);
var
  FName : string;
  Size : integer;
begin
  if imScroll.Visible then
  begin
    nombreFicheroEnvio := txtUbicacionTemporales.Text + 'porta.bmp';
    imagen.Picture.SaveToFile (nombreFicheroEnvio);
  end;
  if txtTexto.Visible and (txtFormato.Text = 'Texto') then
  begin
    nombreFicheroEnvio := txtUbicacionTemporales.Text + 'text.txt';
    txtTexto.Lines.SaveToFile (nombreFicheroEnvio);
  end;

  if (cliente.Active = true) and (FileExists(nombreFicheroEnvio)) then
  begin
    FName :=  nombreFicheroEnvio;
    Stream := TFileStream.Create(Fname,fmopenread);
    Stream.Position := 0;
    Size := Stream.Size;
    memo1.Lines.add('Configurando envo de fichero...');
    memo1.lines.add('Enviando tamao de fichero para ' + ExtractFileName(Fname) + '...');
    cliente.Socket.SendText('!SIZE' + inttostr(Size));
    tamanoFichero := Size;
    Stream.Free;
    sleep(2000);
    cliente.Socket.SendText('!FILE' + ExtractFileName(Fname));
    memo1.lines.add('Enviando nombre de fichero para ' + ExtractFileName(Fname) + '...');
    nombreFicheroEnvio := ExtractFileName(FName);
    sleep(2000);
    socFichero.Host := txtIP.Text;
    socFichero.Open;
  end;
end;

procedure TformMenuPrincipal.btProbarConexionClick(Sender: TObject);
begin
  cliente.Close;
  cliente.host := txtIP.Text;
  cliente.Port := strtoint(txtPuerto.Text);
  cliente.Open;
  txtLog.Lines.Add ('Conectndose a ' + txtIP.Text);
end;

procedure TformMenuPrincipal.btModoEscuchaClick(Sender: TObject);
begin
  servidor.Close;
  servidor.Port := strtoint(txtPuerto.Text);
  txtLog.Lines.Add ('Intentando abrir el puerto para escuchar al PC remoto');
  servidor.Open;
end;

end.
